package com.njcn.energy.controller;

import com.njcn.common.pojo.annotation.OperateInfo;
import com.njcn.common.pojo.enums.common.LogEnum;
import com.njcn.common.pojo.enums.response.CommonResponseEnum;
import com.njcn.common.pojo.response.HttpResult;
import com.njcn.common.utils.HttpResultUtil;
import com.njcn.common.utils.LogUtil;
import com.njcn.energy.pojo.po.EleEpdPqd;
import com.njcn.energy.pojo.po.EleMd;
import com.njcn.energy.service.IEleEpdPqdService;
import com.njcn.energy.service.IEleMdService;
import com.njcn.web.controller.BaseController;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.*;

/**
 * 类的介绍：
 *
 * @author xuyang
 * @version 1.0.0
 * @createTime 2022/3/15 13:30
 */
@Slf4j
@RestController
@RequestMapping("/md")
@RequiredArgsConstructor
@Api(tags = "基础测量数据管理")
public class EleMdController extends BaseController {

    private final IEleMdService eleMdService;

    @PostMapping("/add")
    @OperateInfo(info = LogEnum.SYSTEM_COMMON)
    @ApiOperation("新增基础测量数据")
    @ApiImplicitParam(name = "eleMd", value = "基础测量数据", required = true)
    public HttpResult<Boolean> add(@RequestBody EleMd eleMd){
        String methodDescribe = getMethodDescribe("add");
        LogUtil.njcnDebug(log, "{}，电能质量数据为：{}", methodDescribe, eleMd);
        boolean result = eleMdService.addMd(eleMd);
        return HttpResultUtil.assembleCommonResponseResult(CommonResponseEnum.SUCCESS, result, methodDescribe);
    }

    @PutMapping("/update")
    @OperateInfo(info = LogEnum.SYSTEM_COMMON)
    @ApiOperation("修改基础测量数据")
    @ApiImplicitParam(name = "eleMd", value = "基础测量数据", required = true)
    public HttpResult<Boolean> update(@RequestBody EleMd eleMd){
        String methodDescribe = getMethodDescribe("update");
        LogUtil.njcnDebug(log, "{}，电能质量数据为：{}", methodDescribe, eleMd);
        boolean result = eleMdService.updateMd(eleMd);
        return HttpResultUtil.assembleCommonResponseResult(CommonResponseEnum.SUCCESS, result, methodDescribe);
    }

    @GetMapping("/findByName")
    @OperateInfo(info = LogEnum.SYSTEM_COMMON)
    @ApiOperation("根据名称查找数据")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "name", value = "名称", required = true),
            @ApiImplicitParam(name = "phase", value = "相别", required = true)
    })
    public HttpResult<EleMd> findByName(@RequestParam String name,@RequestParam String phase){
        String methodDescribe = getMethodDescribe("findByName");
        LogUtil.njcnDebug(log, "{}，名称为：{}", methodDescribe, name);
        EleMd eleMd = eleMdService.findByName(name,phase);
        return HttpResultUtil.assembleCommonResponseResult(CommonResponseEnum.SUCCESS, eleMd, methodDescribe);
    }

}
